// This file has been generated by Py++.

#include "boost/python.hpp"

#include "__array_1.pypp.hpp"

#include "mat3x3.h"

#include "vec2.h"

#include "vec3.h"

#include "vec4.h"

#include "quaternion.h"

#include "mat4x4.h"

#include "matrix.h"

namespace bp = boost::python;

struct Mat3x3_wrapper : nacb::Mat3x3, bp::wrapper< nacb::Mat3x3 > {

    Mat3x3_wrapper(nacb::Mat3x3 const & arg )
    : nacb::Mat3x3( arg )
      , bp::wrapper< nacb::Mat3x3 >(){
        // copy constructor
        
    }

    Mat3x3_wrapper( )
    : nacb::Mat3x3( )
      , bp::wrapper< nacb::Mat3x3 >(){
        // null constructor
    
    }

    static pyplusplus::containers::static_sized::array_1_t< double, 9>
    pyplusplus_data_wrapper( ::nacb::Mat3x3 & inst ){
        return pyplusplus::containers::static_sized::array_1_t< double, 9>( inst.data );
    }

};

struct Mat4x4_wrapper : nacb::Mat4x4, bp::wrapper< nacb::Mat4x4 > {

    Mat4x4_wrapper(nacb::Mat4x4 const & arg )
    : nacb::Mat4x4( arg )
      , bp::wrapper< nacb::Mat4x4 >(){
        // copy constructor
        
    }

    Mat4x4_wrapper( )
    : nacb::Mat4x4( )
      , bp::wrapper< nacb::Mat4x4 >(){
        // null constructor
    
    }

    Mat4x4_wrapper(::nacb::Vec3d const & p, ::nacb::Quaternion const & q )
    : nacb::Mat4x4( boost::ref(p), boost::ref(q) )
      , bp::wrapper< nacb::Mat4x4 >(){
        // constructor
    
    }

    static pyplusplus::containers::static_sized::array_1_t< double, 16>
    pyplusplus_data_wrapper( ::nacb::Mat4x4 & inst ){
        return pyplusplus::containers::static_sized::array_1_t< double, 16>( inst.data );
    }

};

struct Matrix_wrapper : nacb::Matrix, bp::wrapper< nacb::Matrix > {

    struct index_error_wrapper : nacb::Matrix::index_error, bp::wrapper< nacb::Matrix::index_error > {
    
        index_error_wrapper(nacb::Matrix::index_error const & arg )
        : nacb::Matrix::index_error( arg )
          , bp::wrapper< nacb::Matrix::index_error >(){
            // copy constructor
            
        }
    
        index_error_wrapper(int i_, int j_, int m_, int n_ )
        : nacb::Matrix::index_error( i_, j_, m_, n_ )
          , bp::wrapper< nacb::Matrix::index_error >(){
            // constructor
        
        }
    
        index_error_wrapper( )
        : nacb::Matrix::index_error( )
          , bp::wrapper< nacb::Matrix::index_error >(){
            // null constructor
        
        }
    
        virtual char const * what(  ) const   throw(){
            if( bp::override func_what = this->get_override( "what" ) )
                return func_what(  );
            else
                return this->nacb::Matrix::index_error::what(  );
        }
        
        
        char const * default_what(  ) const   throw(){
            return nacb::Matrix::index_error::what( );
        }
    
    };

    struct size_mismatch_wrapper : nacb::Matrix::size_mismatch, bp::wrapper< nacb::Matrix::size_mismatch > {
    
        size_mismatch_wrapper(nacb::Matrix::size_mismatch const & arg )
        : nacb::Matrix::size_mismatch( arg )
          , bp::wrapper< nacb::Matrix::size_mismatch >(){
            // copy constructor
            
        }
    
        size_mismatch_wrapper( )
        : nacb::Matrix::size_mismatch( )
          , bp::wrapper< nacb::Matrix::size_mismatch >(){
            // null constructor
        
        }
    
        size_mismatch_wrapper(::nacb::Matrix const & a, ::nacb::Matrix const & b )
        : nacb::Matrix::size_mismatch( boost::ref(a), boost::ref(b) )
          , bp::wrapper< nacb::Matrix::size_mismatch >(){
            // constructor
        
        }
    
        size_mismatch_wrapper(int m1, int n1, int m2, int n2 )
        : nacb::Matrix::size_mismatch( m1, n1, m2, n2 )
          , bp::wrapper< nacb::Matrix::size_mismatch >(){
            // constructor
        
        }
    
        virtual char const * what(  ) const   throw(){
            if( bp::override func_what = this->get_override( "what" ) )
                return func_what(  );
            else
                return this->nacb::Matrix::size_mismatch::what(  );
        }
        
        
        char const * default_what(  ) const   throw(){
            return nacb::Matrix::size_mismatch::what( );
        }
    
    };

    Matrix_wrapper( )
    : nacb::Matrix( )
      , bp::wrapper< nacb::Matrix >(){
        // null constructor
    
    }

    Matrix_wrapper(::nacb::Matrix const & mat )
    : nacb::Matrix( boost::ref(mat) )
      , bp::wrapper< nacb::Matrix >(){
        // copy constructor
    
    }

    Matrix_wrapper(int _m, int _n )
    : nacb::Matrix( _m, _n )
      , bp::wrapper< nacb::Matrix >(){
        // constructor
    
    }

};

BOOST_PYTHON_MODULE(nmath){
    { //::nacb::Mat3x3
        typedef bp::class_< Mat3x3_wrapper > Mat3x3_exposer_t;
        Mat3x3_exposer_t Mat3x3_exposer = Mat3x3_exposer_t( "Mat3x3" );
        bp::scope Mat3x3_scope( Mat3x3_exposer );
        Mat3x3_exposer.def( bp::init< >() );
        { //::nacb::Mat3x3::diag
        
            typedef ::nacb::Mat3x3 ( *diag_function_type )( double,double,double );
            
            Mat3x3_exposer.def( 
                "diag"
                , diag_function_type( &::nacb::Mat3x3::diag )
                , ( bp::arg("a"), bp::arg("b"), bp::arg("c") ) );
        
        }
        { //::nacb::Mat3x3::eye
        
            typedef ::nacb::Mat3x3 ( *eye_function_type )(  );
            
            Mat3x3_exposer.def( 
                "eye"
                , eye_function_type( &::nacb::Mat3x3::eye ) );
        
        }
        { //::nacb::Mat3x3::get
        
            typedef double ( ::nacb::Mat3x3::*get_function_type )( int,int ) const;
            
            Mat3x3_exposer.def( 
                "get"
                , get_function_type( &::nacb::Mat3x3::get )
                , ( bp::arg("i"), bp::arg("j") ) );
        
        }
        { //::nacb::Mat3x3::inverse
        
            typedef ::nacb::Mat3x3 ( ::nacb::Mat3x3::*inverse_function_type )(  ) const;
            
            Mat3x3_exposer.def( 
                "inverse"
                , inverse_function_type( &::nacb::Mat3x3::inverse ) );
        
        }
        Mat3x3_exposer.def( "__str__", &nacb::Mat3x3::operator ::std::string  );
        { //::nacb::Mat3x3::operator()
        
            typedef double & ( ::nacb::Mat3x3::*__call___function_type )( int,int ) ;
            
            Mat3x3_exposer.def( 
                "__call__"
                , __call___function_type( &::nacb::Mat3x3::operator() )
                , ( bp::arg("i"), bp::arg("j") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        Mat3x3_exposer.def( bp::self * bp::self );
        Mat3x3_exposer.def( bp::self + bp::self );
        Mat3x3_exposer.def( bp::self += bp::self );
        Mat3x3_exposer.def( bp::self - bp::self );
        { //::nacb::Mat3x3::operator[]
        
            typedef double & ( ::nacb::Mat3x3::*__getitem___function_type )( int ) ;
            
            Mat3x3_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Mat3x3::operator[] )
                , ( bp::arg("ind") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        { //::nacb::Mat3x3::operator[]
        
            typedef double & ( ::nacb::Mat3x3::*__getitem___function_type )( ::boost::python::tuple const & ) ;
            
            Mat3x3_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Mat3x3::operator[] )
                , ( bp::arg("t") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        { //::nacb::Mat3x3::print
        
            typedef void ( ::nacb::Mat3x3::*print_function_type )( char const * ) const;
            
            Mat3x3_exposer.def( 
                "print"
                , print_function_type( &::nacb::Mat3x3::print )
                , ( bp::arg("name")="" ) );
        
        }
        { //::nacb::Mat3x3::print
        
            typedef void ( ::nacb::Mat3x3::*print_function_type )( ::std::ostream & ) const;
            
            Mat3x3_exposer.def( 
                "print"
                , print_function_type( &::nacb::Mat3x3::print )
                , ( bp::arg("os") ) );
        
        }
        { //::nacb::Mat3x3::python_set
        
            typedef void ( ::nacb::Mat3x3::*python_set_function_type )( ::boost::python::tuple const &,double ) ;
            
            Mat3x3_exposer.def( 
                "python_set"
                , python_set_function_type( &::nacb::Mat3x3::python_set )
                , ( bp::arg("t"), bp::arg("d") ) );
        
        }
        { //::nacb::Mat3x3::set
        
            typedef void ( ::nacb::Mat3x3::*set_function_type )( int,double ) ;
            
            Mat3x3_exposer.def( 
                "set"
                , set_function_type( &::nacb::Mat3x3::set )
                , ( bp::arg("i"), bp::arg("d") ) );
        
        }
        { //::nacb::Mat3x3::transpose
        
            typedef ::nacb::Mat3x3 ( ::nacb::Mat3x3::*transpose_function_type )(  ) const;
            
            Mat3x3_exposer.def( 
                "transpose"
                , transpose_function_type( &::nacb::Mat3x3::transpose ) );
        
        }
        { //::nacb::Mat3x3::zero
        
            typedef void ( ::nacb::Mat3x3::*zero_function_type )(  ) ;
            
            Mat3x3_exposer.def( 
                "zero"
                , zero_function_type( &::nacb::Mat3x3::zero ) );
        
        }
        { //::nacb::Mat3x3::zeros
        
            typedef ::nacb::Mat3x3 ( *zeros_function_type )(  );
            
            Mat3x3_exposer.def( 
                "zeros"
                , zeros_function_type( &::nacb::Mat3x3::zeros ) );
        
        }
        pyplusplus::containers::static_sized::register_array_1< double, 9 >( "__array_1_double_9" );
        { //nacb::Mat3x3::data [variable], type=double[9]
        
            typedef pyplusplus::containers::static_sized::array_1_t< double, 9> ( *array_wrapper_creator )( ::nacb::Mat3x3 & );
            
            Mat3x3_exposer.add_property( "data"
                , bp::make_function( array_wrapper_creator(&Mat3x3_wrapper::pyplusplus_data_wrapper)
                                    , bp::with_custodian_and_ward_postcall< 0, 1 >() ) );
        }
        Mat3x3_exposer.staticmethod( "diag" );
        Mat3x3_exposer.staticmethod( "eye" );
        Mat3x3_exposer.staticmethod( "zeros" );
        Mat3x3_exposer.def( bp::self_ns::str( bp::self ) );
        Mat3x3_exposer.def("__setitem__",&::nacb::Mat3x3::python_set);
    }

    bp::implicitly_convertible< nacb::Mat3x3, std::string >();

    { //::nacb::Mat4x4
        typedef bp::class_< Mat4x4_wrapper > Mat4x4_exposer_t;
        Mat4x4_exposer_t Mat4x4_exposer = Mat4x4_exposer_t( "Mat4x4" );
        bp::scope Mat4x4_scope( Mat4x4_exposer );
        Mat4x4_exposer.def( bp::init< >() );
        Mat4x4_exposer.def( bp::init< nacb::Vec3d const &, nacb::Quaternion const & >(( bp::arg("p"), bp::arg("q") )) );
        { //::nacb::Mat4x4::angleAxis
        
            typedef ::nacb::Mat4x4 ( *angleAxis_function_type )( ::nacb::Vec3d const &,double );
            
            Mat4x4_exposer.def( 
                "angleAxis"
                , angleAxis_function_type( &::nacb::Mat4x4::angleAxis )
                , ( bp::arg("axis"), bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::dx
        
            typedef ::nacb::Mat4x4 ( *dx_function_type )( double );
            
            Mat4x4_exposer.def( 
                "dx"
                , dx_function_type( &::nacb::Mat4x4::dx )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::dx_right
        
            typedef void ( ::nacb::Mat4x4::*dx_right_function_type )( double ) ;
            
            Mat4x4_exposer.def( 
                "dx_right"
                , dx_right_function_type( &::nacb::Mat4x4::dx_right )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::dy
        
            typedef ::nacb::Mat4x4 ( *dy_function_type )( double );
            
            Mat4x4_exposer.def( 
                "dy"
                , dy_function_type( &::nacb::Mat4x4::dy )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::dy_right
        
            typedef void ( ::nacb::Mat4x4::*dy_right_function_type )( double ) ;
            
            Mat4x4_exposer.def( 
                "dy_right"
                , dy_right_function_type( &::nacb::Mat4x4::dy_right )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::dz
        
            typedef ::nacb::Mat4x4 ( *dz_function_type )( double );
            
            Mat4x4_exposer.def( 
                "dz"
                , dz_function_type( &::nacb::Mat4x4::dz )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::dz_right
        
            typedef void ( ::nacb::Mat4x4::*dz_right_function_type )( double ) ;
            
            Mat4x4_exposer.def( 
                "dz_right"
                , dz_right_function_type( &::nacb::Mat4x4::dz_right )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::eucInv
        
            typedef ::nacb::Mat4x4 ( ::nacb::Mat4x4::*eucInv_function_type )(  ) const;
            
            Mat4x4_exposer.def( 
                "eucInv"
                , eucInv_function_type( &::nacb::Mat4x4::eucInv ) );
        
        }
        { //::nacb::Mat4x4::eye
        
            typedef ::nacb::Mat4x4 ( *eye_function_type )(  );
            
            Mat4x4_exposer.def( 
                "eye"
                , eye_function_type( &::nacb::Mat4x4::eye ) );
        
        }
        { //::nacb::Mat4x4::get
        
            typedef double ( ::nacb::Mat4x4::*get_function_type )( int,int ) const;
            
            Mat4x4_exposer.def( 
                "get"
                , get_function_type( &::nacb::Mat4x4::get )
                , ( bp::arg("i"), bp::arg("j") ) );
        
        }
        { //::nacb::Mat4x4::glMult
        
            typedef void ( ::nacb::Mat4x4::*glMult_function_type )(  ) const;
            
            Mat4x4_exposer.def( 
                "glMult"
                , glMult_function_type( &::nacb::Mat4x4::glMult ) );
        
        }
        { //::nacb::Mat4x4::inverse
        
            typedef ::nacb::Mat4x4 ( ::nacb::Mat4x4::*inverse_function_type )(  ) const;
            
            Mat4x4_exposer.def( 
                "inverse"
                , inverse_function_type( &::nacb::Mat4x4::inverse ) );
        
        }
        { //::nacb::Mat4x4::len
        
            typedef double ( ::nacb::Mat4x4::*len_function_type )(  ) const;
            
            Mat4x4_exposer.def( 
                "len"
                , len_function_type( &::nacb::Mat4x4::len ) );
        
        }
        { //::nacb::Mat4x4::modelview
        
            typedef ::nacb::Mat4x4 ( *modelview_function_type )(  );
            
            Mat4x4_exposer.def( 
                "modelview"
                , modelview_function_type( &::nacb::Mat4x4::modelview ) );
        
        }
        { //::nacb::Mat4x4::mult_right
        
            typedef void ( ::nacb::Mat4x4::*mult_right_function_type )( ::nacb::Mat4x4 const & ) ;
            
            Mat4x4_exposer.def( 
                "mult_right"
                , mult_right_function_type( &::nacb::Mat4x4::mult_right )
                , ( bp::arg("other") ) );
        
        }
        Mat4x4_exposer.def( "__str__", &nacb::Mat4x4::operator ::std::string  );
        { //::nacb::Mat4x4::operator()
        
            typedef double & ( ::nacb::Mat4x4::*__call___function_type )( int,int ) ;
            
            Mat4x4_exposer.def( 
                "__call__"
                , __call___function_type( &::nacb::Mat4x4::operator() )
                , ( bp::arg("i"), bp::arg("j") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        Mat4x4_exposer.def( bp::self * bp::self );
        Mat4x4_exposer.def( bp::self * bp::other< nacb::Vec4<double> >() );
        Mat4x4_exposer.def( bp::self * bp::other< double >() );
        Mat4x4_exposer.def( bp::self *= bp::self );
        Mat4x4_exposer.def( bp::self + bp::self );
        Mat4x4_exposer.def( bp::self - bp::self );
        { //::nacb::Mat4x4::operator=
        
            typedef void ( ::nacb::Mat4x4::*assign_function_type )( ::nacb::Mat4x4 const & ) ;
            
            Mat4x4_exposer.def( 
                "assign"
                , assign_function_type( &::nacb::Mat4x4::operator= )
                , ( bp::arg("other") ) );
        
        }
        { //::nacb::Mat4x4::operator[]
        
            typedef double & ( ::nacb::Mat4x4::*__getitem___function_type )( int ) ;
            
            Mat4x4_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Mat4x4::operator[] )
                , ( bp::arg("ind") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        { //::nacb::Mat4x4::operator[]
        
            typedef double & ( ::nacb::Mat4x4::*__getitem___function_type )( ::boost::python::tuple const & ) ;
            
            Mat4x4_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Mat4x4::operator[] )
                , ( bp::arg("t") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        { //::nacb::Mat4x4::print
        
            typedef void ( ::nacb::Mat4x4::*print_function_type )( char const * ) const;
            
            Mat4x4_exposer.def( 
                "print"
                , print_function_type( &::nacb::Mat4x4::print )
                , ( bp::arg("name")="" ) );
        
        }
        { //::nacb::Mat4x4::print
        
            typedef void ( ::nacb::Mat4x4::*print_function_type )( ::std::ostream & ) const;
            
            Mat4x4_exposer.def( 
                "print"
                , print_function_type( &::nacb::Mat4x4::print )
                , ( bp::arg("os") ) );
        
        }
        { //::nacb::Mat4x4::projection
        
            typedef ::nacb::Mat4x4 ( *projection_function_type )(  );
            
            Mat4x4_exposer.def( 
                "projection"
                , projection_function_type( &::nacb::Mat4x4::projection ) );
        
        }
        { //::nacb::Mat4x4::python_set
        
            typedef void ( ::nacb::Mat4x4::*python_set_function_type )( ::boost::python::tuple const &,double ) ;
            
            Mat4x4_exposer.def( 
                "python_set"
                , python_set_function_type( &::nacb::Mat4x4::python_set )
                , ( bp::arg("t"), bp::arg("d") ) );
        
        }
        { //::nacb::Mat4x4::rand
        
            typedef ::nacb::Mat4x4 ( *rand_function_type )( double,double );
            
            Mat4x4_exposer.def( 
                "rand"
                , rand_function_type( &::nacb::Mat4x4::rand )
                , ( bp::arg("n")=0, bp::arg("x")=1 ) );
        
        }
        { //::nacb::Mat4x4::rotx
        
            typedef ::nacb::Mat4x4 ( *rotx_function_type )( double );
            
            Mat4x4_exposer.def( 
                "rotx"
                , rotx_function_type( &::nacb::Mat4x4::rotx )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::rotx_right
        
            typedef void ( ::nacb::Mat4x4::*rotx_right_function_type )( double ) ;
            
            Mat4x4_exposer.def( 
                "rotx_right"
                , rotx_right_function_type( &::nacb::Mat4x4::rotx_right )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::roty
        
            typedef ::nacb::Mat4x4 ( *roty_function_type )( double );
            
            Mat4x4_exposer.def( 
                "roty"
                , roty_function_type( &::nacb::Mat4x4::roty )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::roty_right
        
            typedef void ( ::nacb::Mat4x4::*roty_right_function_type )( double ) ;
            
            Mat4x4_exposer.def( 
                "roty_right"
                , roty_right_function_type( &::nacb::Mat4x4::roty_right )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::rotz
        
            typedef ::nacb::Mat4x4 ( *rotz_function_type )( double );
            
            Mat4x4_exposer.def( 
                "rotz"
                , rotz_function_type( &::nacb::Mat4x4::rotz )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::rotz_right
        
            typedef void ( ::nacb::Mat4x4::*rotz_right_function_type )( double ) ;
            
            Mat4x4_exposer.def( 
                "rotz_right"
                , rotz_right_function_type( &::nacb::Mat4x4::rotz_right )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::scale
        
            typedef ::nacb::Mat4x4 ( *scale_function_type )( double,double,double );
            
            Mat4x4_exposer.def( 
                "scale"
                , scale_function_type( &::nacb::Mat4x4::scale )
                , ( bp::arg("sx"), bp::arg("sy"), bp::arg("sz") ) );
        
        }
        { //::nacb::Mat4x4::to_eye
        
            typedef void ( ::nacb::Mat4x4::*to_eye_function_type )(  ) ;
            
            Mat4x4_exposer.def( 
                "to_eye"
                , to_eye_function_type( &::nacb::Mat4x4::to_eye ) );
        
        }
        { //::nacb::Mat4x4::trans
        
            typedef ::nacb::Mat4x4 ( *trans_function_type )( ::nacb::Vec3d const & );
            
            Mat4x4_exposer.def( 
                "trans"
                , trans_function_type( &::nacb::Mat4x4::trans )
                , ( bp::arg("t") ) );
        
        }
        { //::nacb::Mat4x4::trans
        
            typedef ::nacb::Mat4x4 ( *trans_function_type )( double,double,double );
            
            Mat4x4_exposer.def( 
                "trans"
                , trans_function_type( &::nacb::Mat4x4::trans )
                , ( bp::arg("x"), bp::arg("y"), bp::arg("z") ) );
        
        }
        { //::nacb::Mat4x4::trans_left
        
            typedef void ( ::nacb::Mat4x4::*trans_left_function_type )( double,double,double ) ;
            
            Mat4x4_exposer.def( 
                "trans_left"
                , trans_left_function_type( &::nacb::Mat4x4::trans_left )
                , ( bp::arg("x"), bp::arg("y"), bp::arg("z") ) );
        
        }
        { //::nacb::Mat4x4::trans_right
        
            typedef void ( ::nacb::Mat4x4::*trans_right_function_type )( double,double,double ) ;
            
            Mat4x4_exposer.def( 
                "trans_right"
                , trans_right_function_type( &::nacb::Mat4x4::trans_right )
                , ( bp::arg("x"), bp::arg("y"), bp::arg("z") ) );
        
        }
        { //::nacb::Mat4x4::transpose
        
            typedef ::nacb::Mat4x4 ( ::nacb::Mat4x4::*transpose_function_type )(  ) const;
            
            Mat4x4_exposer.def( 
                "transpose"
                , transpose_function_type( &::nacb::Mat4x4::transpose ) );
        
        }
        { //::nacb::Mat4x4::zero
        
            typedef void ( ::nacb::Mat4x4::*zero_function_type )(  ) ;
            
            Mat4x4_exposer.def( 
                "zero"
                , zero_function_type( &::nacb::Mat4x4::zero ) );
        
        }
        { //::nacb::Mat4x4::zeros
        
            typedef ::nacb::Mat4x4 ( *zeros_function_type )(  );
            
            Mat4x4_exposer.def( 
                "zeros"
                , zeros_function_type( &::nacb::Mat4x4::zeros ) );
        
        }
        pyplusplus::containers::static_sized::register_array_1< double, 16 >( "__array_1_double_16" );
        { //nacb::Mat4x4::data [variable], type=double[16]
        
            typedef pyplusplus::containers::static_sized::array_1_t< double, 16> ( *array_wrapper_creator )( ::nacb::Mat4x4 & );
            
            Mat4x4_exposer.add_property( "data"
                , bp::make_function( array_wrapper_creator(&Mat4x4_wrapper::pyplusplus_data_wrapper)
                                    , bp::with_custodian_and_ward_postcall< 0, 1 >() ) );
        }
        Mat4x4_exposer.staticmethod( "angleAxis" );
        Mat4x4_exposer.staticmethod( "dx" );
        Mat4x4_exposer.staticmethod( "dy" );
        Mat4x4_exposer.staticmethod( "dz" );
        Mat4x4_exposer.staticmethod( "eye" );
        Mat4x4_exposer.staticmethod( "modelview" );
        Mat4x4_exposer.staticmethod( "projection" );
        Mat4x4_exposer.staticmethod( "rand" );
        Mat4x4_exposer.staticmethod( "rotx" );
        Mat4x4_exposer.staticmethod( "roty" );
        Mat4x4_exposer.staticmethod( "rotz" );
        Mat4x4_exposer.staticmethod( "scale" );
        Mat4x4_exposer.staticmethod( "trans" );
        Mat4x4_exposer.staticmethod( "zeros" );
        Mat4x4_exposer.def("__setitem__",&::nacb::Mat4x4::python_set);
    }

    bp::implicitly_convertible< nacb::Mat4x4, std::string >();

    { //::nacb::Matrix
        typedef bp::class_< Matrix_wrapper > Matrix_exposer_t;
        Matrix_exposer_t Matrix_exposer = Matrix_exposer_t( "Matrix" );
        bp::scope Matrix_scope( Matrix_exposer );
        bp::class_< Matrix_wrapper::index_error_wrapper >( "index_error" )    
            .def( bp::init< int, int, int, int >(( bp::arg("i_"), bp::arg("j_"), bp::arg("m_"), bp::arg("n_") )) )    
            .def( bp::init< >() )    
            .def( 
                "what"
                , &::nacb::Matrix::index_error::what
                , &Matrix_wrapper::index_error_wrapper::default_what );
        bp::class_< Matrix_wrapper::size_mismatch_wrapper >( "size_mismatch" )    
            .def( bp::init< >() )    
            .def( bp::init< nacb::Matrix const &, nacb::Matrix const & >(( bp::arg("a"), bp::arg("b") )) )    
            .def( bp::init< int, int, int, int >(( bp::arg("m1"), bp::arg("n1"), bp::arg("m2"), bp::arg("n2") )) )    
            .def( 
                "what"
                , &::nacb::Matrix::size_mismatch::what
                , &Matrix_wrapper::size_mismatch_wrapper::default_what )    
            .def_readwrite( "have_dims", &nacb::Matrix::size_mismatch::have_dims )    
            .def_readwrite( "m1", &nacb::Matrix::size_mismatch::m1 )    
            .def_readwrite( "m2", &nacb::Matrix::size_mismatch::m2 )    
            .def_readwrite( "n1", &nacb::Matrix::size_mismatch::n1 )    
            .def_readwrite( "n2", &nacb::Matrix::size_mismatch::n2 );
        Matrix_exposer.def( bp::init< >() );
        Matrix_exposer.def( bp::init< nacb::Matrix const & >(( bp::arg("mat") )) );
        Matrix_exposer.def( bp::init< int, int >(( bp::arg("_m"), bp::arg("_n") )) );
        { //::nacb::Matrix::LlinLeastSq
        
            typedef ::nacb::Matrix ( *LlinLeastSq_function_type )( ::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix & );
            
            Matrix_exposer.def( 
                "LlinLeastSq"
                , LlinLeastSq_function_type( &::nacb::Matrix::LlinLeastSq )
                , ( bp::arg("A"), bp::arg("b"), bp::arg("B"), bp::arg("d") ) );
        
        }
        { //::nacb::Matrix::LlinLeastSq
        
            typedef ::nacb::Matrix ( *LlinLeastSq_function_type )( ::nacb::Matrix &,::nacb::Matrix & );
            
            Matrix_exposer.def( 
                "LlinLeastSq"
                , LlinLeastSq_function_type( &::nacb::Matrix::LlinLeastSq )
                , ( bp::arg("A"), bp::arg("b") ) );
        
        }
        { //::nacb::Matrix::Lqr
        
            typedef void ( ::nacb::Matrix::*Lqr_function_type )( ::nacb::Matrix &,::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "Lqr"
                , Lqr_function_type( &::nacb::Matrix::Lqr )
                , ( bp::arg("Q"), bp::arg("R") ) );
        
        }
        { //::nacb::Matrix::Lsvd
        
            typedef void ( ::nacb::Matrix::*Lsvd_function_type )( ::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "Lsvd"
                , Lsvd_function_type( &::nacb::Matrix::Lsvd )
                , ( bp::arg("a"), bp::arg("w"), bp::arg("v") ) );
        
        }
        { //::nacb::Matrix::LsvdLarge
        
            typedef void ( ::nacb::Matrix::*LsvdLarge_function_type )( ::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "LsvdLarge"
                , LsvdLarge_function_type( &::nacb::Matrix::LsvdLarge )
                , ( bp::arg("a"), bp::arg("w"), bp::arg("v") ) );
        
        }
        { //::nacb::Matrix::copy
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*copy_function_type )(  ) const;
            
            Matrix_exposer.def( 
                "copy"
                , copy_function_type( &::nacb::Matrix::copy ) );
        
        }
        { //::nacb::Matrix::destroy
        
            typedef void ( ::nacb::Matrix::*destroy_function_type )(  ) ;
            
            Matrix_exposer.def( 
                "destroy"
                , destroy_function_type( &::nacb::Matrix::destroy ) );
        
        }
        { //::nacb::Matrix::det
        
            typedef double ( ::nacb::Matrix::*det_function_type )(  ) const;
            
            Matrix_exposer.def( 
                "det"
                , det_function_type( &::nacb::Matrix::det ) );
        
        }
        { //::nacb::Matrix::diag
        
            typedef ::nacb::Matrix ( *diag_function_type )( ::nacb::Matrix const & );
            
            Matrix_exposer.def( 
                "diag"
                , diag_function_type( &::nacb::Matrix::diag )
                , ( bp::arg("d") ) );
        
        }
        { //::nacb::Matrix::dot
        
            typedef double ( ::nacb::Matrix::*dot_function_type )( ::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "dot"
                , dot_function_type( &::nacb::Matrix::dot )
                , ( bp::arg("other") ) );
        
        }
        { //::nacb::Matrix::dotmult
        
            typedef void ( ::nacb::Matrix::*dotmult_function_type )( ::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "dotmult"
                , dotmult_function_type( &::nacb::Matrix::dotmult )
                , ( bp::arg("other") ) );
        
        }
        { //::nacb::Matrix::eigSym
        
            typedef void ( ::nacb::Matrix::*eigSym_function_type )( ::nacb::Matrix &,::nacb::Matrix &,int ) ;
            
            Matrix_exposer.def( 
                "eigSym"
                , eigSym_function_type( &::nacb::Matrix::eigSym )
                , ( bp::arg("eigVectors"), bp::arg("eigenValues"), bp::arg("toget")=(int)(-1) ) );
        
        }
        { //::nacb::Matrix::eye
        
            typedef ::nacb::Matrix ( *eye_function_type )( int,int );
            
            Matrix_exposer.def( 
                "eye"
                , eye_function_type( &::nacb::Matrix::eye )
                , ( bp::arg("m"), bp::arg("n") ) );
        
        }
        { //::nacb::Matrix::eye
        
            typedef ::nacb::Matrix ( *eye_function_type )( int );
            
            Matrix_exposer.def( 
                "eye"
                , eye_function_type( &::nacb::Matrix::eye )
                , ( bp::arg("size") ) );
        
        }
        { //::nacb::Matrix::get
        
            typedef double ( ::nacb::Matrix::*get_function_type )( int ) const;
            
            Matrix_exposer.def( 
                "get"
                , get_function_type( &::nacb::Matrix::get )
                , ( bp::arg("i") ) );
        
        }
        { //::nacb::Matrix::get
        
            typedef double ( ::nacb::Matrix::*get_function_type )( int,int ) const;
            
            Matrix_exposer.def( 
                "get"
                , get_function_type( &::nacb::Matrix::get )
                , ( bp::arg("i"), bp::arg("j") ) );
        
        }
        { //::nacb::Matrix::getCols
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*getCols_function_type )( int const *,int ) ;
            
            Matrix_exposer.def( 
                "getCols"
                , getCols_function_type( &::nacb::Matrix::getCols )
                , ( bp::arg("which"), bp::arg("ncols") ) );
        
        }
        { //::nacb::Matrix::getColumn
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*getColumn_function_type )( int ) const;
            
            Matrix_exposer.def( 
                "getColumn"
                , getColumn_function_type( &::nacb::Matrix::getColumn )
                , ( bp::arg("j") ) );
        
        }
        { //::nacb::Matrix::getRow
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*getRow_function_type )( int ) const;
            
            Matrix_exposer.def( 
                "getRow"
                , getRow_function_type( &::nacb::Matrix::getRow )
                , ( bp::arg("i") ) );
        
        }
        { //::nacb::Matrix::inverse
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*inverse_function_type )(  ) const;
            
            Matrix_exposer.def( 
                "inverse"
                , inverse_function_type( &::nacb::Matrix::inverse ) );
        
        }
        { //::nacb::Matrix::linLeastSq
        
            typedef ::nacb::Matrix ( *linLeastSq_function_type )( ::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix & );
            
            Matrix_exposer.def( 
                "linLeastSq"
                , linLeastSq_function_type( &::nacb::Matrix::linLeastSq )
                , ( bp::arg("A"), bp::arg("b"), bp::arg("B"), bp::arg("d") ) );
        
        }
        { //::nacb::Matrix::linLeastSq
        
            typedef ::nacb::Matrix ( *linLeastSq_function_type )( ::nacb::Matrix &,::nacb::Matrix & );
            
            Matrix_exposer.def( 
                "linLeastSq"
                , linLeastSq_function_type( &::nacb::Matrix::linLeastSq )
                , ( bp::arg("A"), bp::arg("b") ) );
        
        }
        { //::nacb::Matrix::matrix2rod
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*matrix2rod_function_type )(  ) ;
            
            Matrix_exposer.def( 
                "matrix2rod"
                , matrix2rod_function_type( &::nacb::Matrix::matrix2rod ) );
        
        }
        { //::nacb::Matrix::maxInCol
        
            typedef double ( ::nacb::Matrix::*maxInCol_function_type )( int ) const;
            
            Matrix_exposer.def( 
                "maxInCol"
                , maxInCol_function_type( &::nacb::Matrix::maxInCol )
                , ( bp::arg("j") ) );
        
        }
        { //::nacb::Matrix::maxInRow
        
            typedef double ( ::nacb::Matrix::*maxInRow_function_type )( int ) const;
            
            Matrix_exposer.def( 
                "maxInRow"
                , maxInRow_function_type( &::nacb::Matrix::maxInRow )
                , ( bp::arg("i") ) );
        
        }
        { //::nacb::Matrix::meanAll
        
            typedef double ( ::nacb::Matrix::*meanAll_function_type )(  ) ;
            
            Matrix_exposer.def( 
                "meanAll"
                , meanAll_function_type( &::nacb::Matrix::meanAll ) );
        
        }
        { //::nacb::Matrix::minInCol
        
            typedef double ( ::nacb::Matrix::*minInCol_function_type )( int ) const;
            
            Matrix_exposer.def( 
                "minInCol"
                , minInCol_function_type( &::nacb::Matrix::minInCol )
                , ( bp::arg("j") ) );
        
        }
        { //::nacb::Matrix::minInRow
        
            typedef double ( ::nacb::Matrix::*minInRow_function_type )( int ) const;
            
            Matrix_exposer.def( 
                "minInRow"
                , minInRow_function_type( &::nacb::Matrix::minInRow )
                , ( bp::arg("i") ) );
        
        }
        Matrix_exposer.def( "__str__", &nacb::Matrix::operator ::std::string  );
        { //::nacb::Matrix::operator()
        
            typedef double & ( ::nacb::Matrix::*__call___function_type )( int,int ) const;
            
            Matrix_exposer.def( 
                "__call__"
                , __call___function_type( &::nacb::Matrix::operator() )
                , ( bp::arg("i"), bp::arg("j") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        Matrix_exposer.def( bp::self * bp::other< double >() );
        Matrix_exposer.def( bp::self * bp::self );
        Matrix_exposer.def( bp::self *= bp::other< double >() );
        Matrix_exposer.def( bp::self + bp::self );
        Matrix_exposer.def( bp::self += bp::self );
        Matrix_exposer.def( bp::self += bp::other< double >() );
        Matrix_exposer.def( bp::self - bp::self );
        Matrix_exposer.def( bp::self -= bp::self );
        { //::nacb::Matrix::operator=
        
            typedef void ( ::nacb::Matrix::*assign_function_type )( ::nacb::Mat4x4 const & ) ;
            
            Matrix_exposer.def( 
                "assign"
                , assign_function_type( &::nacb::Matrix::operator= )
                , ( bp::arg("mat") ) );
        
        }
        { //::nacb::Matrix::operator=
        
            typedef void ( ::nacb::Matrix::*assign_function_type )( ::nacb::Mat3x3 const & ) ;
            
            Matrix_exposer.def( 
                "assign"
                , assign_function_type( &::nacb::Matrix::operator= )
                , ( bp::arg("mat") ) );
        
        }
        { //::nacb::Matrix::operator=
        
            typedef void ( ::nacb::Matrix::*assign_function_type )( ::nacb::Matrix const & ) ;
            
            Matrix_exposer.def( 
                "assign"
                , assign_function_type( &::nacb::Matrix::operator= )
                , ( bp::arg("other") ) );
        
        }
        { //::nacb::Matrix::operator[]
        
            typedef double & ( ::nacb::Matrix::*__getitem___function_type )( int ) const;
            
            Matrix_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Matrix::operator[] )
                , ( bp::arg("i") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        { //::nacb::Matrix::operator[]
        
            typedef double & ( ::nacb::Matrix::*__getitem___function_type )( ::boost::python::tuple const & ) ;
            
            Matrix_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Matrix::operator[] )
                , ( bp::arg("t") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        { //::nacb::Matrix::print
        
            typedef void ( ::nacb::Matrix::*print_function_type )(  ) ;
            
            Matrix_exposer.def( 
                "print"
                , print_function_type( &::nacb::Matrix::print ) );
        
        }
        { //::nacb::Matrix::print
        
            typedef void ( ::nacb::Matrix::*print_function_type )( ::std::ostream & ) const;
            
            Matrix_exposer.def( 
                "print"
                , print_function_type( &::nacb::Matrix::print )
                , ( bp::arg("ost") ) );
        
        }
        { //::nacb::Matrix::python_set
        
            typedef void ( ::nacb::Matrix::*python_set_function_type )( ::boost::python::tuple const &,double ) ;
            
            Matrix_exposer.def( 
                "python_set"
                , python_set_function_type( &::nacb::Matrix::python_set )
                , ( bp::arg("t"), bp::arg("d") ) );
        
        }
        { //::nacb::Matrix::python_set_arr
        
            typedef void ( ::nacb::Matrix::*python_set_arr_function_type )( int,double ) ;
            
            Matrix_exposer.def( 
                "python_set_arr"
                , python_set_arr_function_type( &::nacb::Matrix::python_set_arr )
                , ( bp::arg("i"), bp::arg("d") ) );
        
        }
        { //::nacb::Matrix::qr
        
            typedef int ( ::nacb::Matrix::*qr_function_type )( ::nacb::Matrix &,::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "qr"
                , qr_function_type( &::nacb::Matrix::qr )
                , ( bp::arg("Q"), bp::arg("R") ) );
        
        }
        { //::nacb::Matrix::random
        
            typedef ::nacb::Matrix ( *random_function_type )( int,int );
            
            Matrix_exposer.def( 
                "random"
                , random_function_type( &::nacb::Matrix::random )
                , ( bp::arg("m"), bp::arg("n") ) );
        
        }
        { //::nacb::Matrix::rod2matrix
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*rod2matrix_function_type )(  ) ;
            
            Matrix_exposer.def( 
                "rod2matrix"
                , rod2matrix_function_type( &::nacb::Matrix::rod2matrix ) );
        
        }
        { //::nacb::Matrix::rot2D
        
            typedef ::nacb::Matrix ( *rot2D_function_type )( double );
            
            Matrix_exposer.def( 
                "rot2D"
                , rot2D_function_type( &::nacb::Matrix::rot2D )
                , ( bp::arg("theta") ) );
        
        }
        { //::nacb::Matrix::rot2xyz
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*rot2xyz_function_type )(  ) ;
            
            Matrix_exposer.def( 
                "rot2xyz"
                , rot2xyz_function_type( &::nacb::Matrix::rot2xyz ) );
        
        }
        { //::nacb::Matrix::rot2zxy
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*rot2zxy_function_type )(  ) ;
            
            Matrix_exposer.def( 
                "rot2zxy"
                , rot2zxy_function_type( &::nacb::Matrix::rot2zxy ) );
        
        }
        { //::nacb::Matrix::rotx
        
            typedef ::nacb::Matrix ( *rotx_function_type )( double );
            
            Matrix_exposer.def( 
                "rotx"
                , rotx_function_type( &::nacb::Matrix::rotx )
                , ( bp::arg("theta") ) );
        
        }
        { //::nacb::Matrix::roty
        
            typedef ::nacb::Matrix ( *roty_function_type )( double );
            
            Matrix_exposer.def( 
                "roty"
                , roty_function_type( &::nacb::Matrix::roty )
                , ( bp::arg("theta") ) );
        
        }
        { //::nacb::Matrix::rotz
        
            typedef ::nacb::Matrix ( *rotz_function_type )( double );
            
            Matrix_exposer.def( 
                "rotz"
                , rotz_function_type( &::nacb::Matrix::rotz )
                , ( bp::arg("theta") ) );
        
        }
        { //::nacb::Matrix::scale
        
            typedef ::nacb::Matrix ( *scale_function_type )( double,double,double );
            
            Matrix_exposer.def( 
                "scale"
                , scale_function_type( &::nacb::Matrix::scale )
                , ( bp::arg("sx"), bp::arg("sy"), bp::arg("sz") ) );
        
        }
        { //::nacb::Matrix::set
        
            typedef void ( ::nacb::Matrix::*set_function_type )( int,int,double ) ;
            
            Matrix_exposer.def( 
                "set"
                , set_function_type( &::nacb::Matrix::set )
                , ( bp::arg("i"), bp::arg("j"), bp::arg("val") ) );
        
        }
        { //::nacb::Matrix::setAll
        
            typedef void ( ::nacb::Matrix::*setAll_function_type )( double ) ;
            
            Matrix_exposer.def( 
                "setAll"
                , setAll_function_type( &::nacb::Matrix::setAll )
                , ( bp::arg("d") ) );
        
        }
        { //::nacb::Matrix::setSubmatrix
        
            typedef void ( ::nacb::Matrix::*setSubmatrix_function_type )( int,int,::nacb::Matrix const & ) ;
            
            Matrix_exposer.def( 
                "setSubmatrix"
                , setSubmatrix_function_type( &::nacb::Matrix::setSubmatrix )
                , ( bp::arg("i0"), bp::arg("j0"), bp::arg("subm") ) );
        
        }
        { //::nacb::Matrix::sqrt
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*sqrt_function_type )(  ) const;
            
            Matrix_exposer.def( 
                "sqrt"
                , sqrt_function_type( &::nacb::Matrix::sqrt ) );
        
        }
        { //::nacb::Matrix::submatrix
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*submatrix_function_type )( int,int,int,int ) const;
            
            Matrix_exposer.def( 
                "submatrix"
                , submatrix_function_type( &::nacb::Matrix::submatrix )
                , ( bp::arg("i0"), bp::arg("j0"), bp::arg("nrows"), bp::arg("ncols") ) );
        
        }
        { //::nacb::Matrix::svd
        
            typedef void ( ::nacb::Matrix::*svd_function_type )( ::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "svd"
                , svd_function_type( &::nacb::Matrix::svd )
                , ( bp::arg("a"), bp::arg("w"), bp::arg("v") ) );
        
        }
        { //::nacb::Matrix::svdLarge
        
            typedef void ( ::nacb::Matrix::*svdLarge_function_type )( ::nacb::Matrix &,::nacb::Matrix &,::nacb::Matrix & ) ;
            
            Matrix_exposer.def( 
                "svdLarge"
                , svdLarge_function_type( &::nacb::Matrix::svdLarge )
                , ( bp::arg("a"), bp::arg("w"), bp::arg("v") ) );
        
        }
        { //::nacb::Matrix::trans
        
            typedef ::nacb::Matrix ( *trans_function_type )( double,double,double );
            
            Matrix_exposer.def( 
                "trans"
                , trans_function_type( &::nacb::Matrix::trans )
                , ( bp::arg("x"), bp::arg("y"), bp::arg("z") ) );
        
        }
        { //::nacb::Matrix::trans2D
        
            typedef ::nacb::Matrix ( *trans2D_function_type )( double,double );
            
            Matrix_exposer.def( 
                "trans2D"
                , trans2D_function_type( &::nacb::Matrix::trans2D )
                , ( bp::arg("x"), bp::arg("y") ) );
        
        }
        { //::nacb::Matrix::transpose
        
            typedef ::nacb::Matrix ( ::nacb::Matrix::*transpose_function_type )(  ) const;
            
            Matrix_exposer.def( 
                "transpose"
                , transpose_function_type( &::nacb::Matrix::transpose ) );
        
        }
        { //::nacb::Matrix::zeros
        
            typedef ::nacb::Matrix ( *zeros_function_type )( int,int );
            
            Matrix_exposer.def( 
                "zeros"
                , zeros_function_type( &::nacb::Matrix::zeros )
                , ( bp::arg("m"), bp::arg("n") ) );
        
        }
        Matrix_exposer.def_readwrite( "m", &nacb::Matrix::m );
        Matrix_exposer.def_readwrite( "n", &nacb::Matrix::n );
        Matrix_exposer.staticmethod( "LlinLeastSq" );
        Matrix_exposer.staticmethod( "diag" );
        Matrix_exposer.staticmethod( "eye" );
        Matrix_exposer.staticmethod( "linLeastSq" );
        Matrix_exposer.staticmethod( "random" );
        Matrix_exposer.staticmethod( "rot2D" );
        Matrix_exposer.staticmethod( "rotx" );
        Matrix_exposer.staticmethod( "roty" );
        Matrix_exposer.staticmethod( "rotz" );
        Matrix_exposer.staticmethod( "scale" );
        Matrix_exposer.staticmethod( "trans" );
        Matrix_exposer.staticmethod( "trans2D" );
        Matrix_exposer.staticmethod( "zeros" );
        Matrix_exposer.def("__setitem__",&::nacb::Matrix::python_set);
    }

    bp::implicitly_convertible< nacb::Matrix, std::string >();

    { //::nacb::Vec3<double>
        typedef bp::class_< nacb::Vec3<double> > Vec3d_exposer_t;
        Vec3d_exposer_t Vec3d_exposer = Vec3d_exposer_t( "Vec3d", bp::init< nacb::Vec3<double> const & >(( bp::arg("other") )) );
        bp::scope Vec3d_scope( Vec3d_exposer );
        Vec3d_exposer.def( bp::init< bp::optional< double, double, double > >(( bp::arg("x")=0, bp::arg("y")=0, bp::arg("z")=0 )) );
        { //::nacb::Vec3<double>::cross
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef ::nacb::Vec3<double> ( exported_class_t::*cross_function_type )( ::nacb::Vec3<double> const & ) const;
            
            Vec3d_exposer.def( 
                "cross"
                , cross_function_type( &::nacb::Vec3<double>::cross )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<double>::dot
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef double ( exported_class_t::*dot_function_type )( ::nacb::Vec3<double> const & ) const;
            
            Vec3d_exposer.def( 
                "dot"
                , dot_function_type( &::nacb::Vec3<double>::dot )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<double>::getData
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef double * ( exported_class_t::*getData_function_type )(  ) ;
            
            Vec3d_exposer.def( 
                "getData"
                , getData_function_type( &::nacb::Vec3<double>::getData )
                , bp::return_value_policy< bp::return_by_value >() );
        
        }
        { //::nacb::Vec3<double>::len
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef double ( exported_class_t::*len_function_type )(  ) const;
            
            Vec3d_exposer.def( 
                "len"
                , len_function_type( &::nacb::Vec3<double>::len ) );
        
        }
        { //::nacb::Vec3<double>::max
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef ::nacb::Vec3<double> ( exported_class_t::*max_function_type )( ::nacb::Vec3<double> const & ) const;
            
            Vec3d_exposer.def( 
                "max"
                , max_function_type( &::nacb::Vec3<double>::max )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<double>::min
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef ::nacb::Vec3<double> ( exported_class_t::*min_function_type )( ::nacb::Vec3<double> const & ) const;
            
            Vec3d_exposer.def( 
                "min"
                , min_function_type( &::nacb::Vec3<double>::min )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<double>::normalize
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef double ( exported_class_t::*normalize_function_type )(  ) ;
            
            Vec3d_exposer.def( 
                "normalize"
                , normalize_function_type( &::nacb::Vec3<double>::normalize ) );
        
        }
        Vec3d_exposer.def( "__str__", &nacb::Vec3<double>::operator ::std::string  );
        Vec3d_exposer.def( bp::self * bp::self );
        Vec3d_exposer.def( bp::self * bp::other< double >() );
        Vec3d_exposer.def( bp::self *= bp::other< double >() );
        Vec3d_exposer.def( bp::self + bp::self );
        Vec3d_exposer.def( bp::self += bp::self );
        Vec3d_exposer.def( bp::self - bp::self );
        Vec3d_exposer.def( bp::self -= bp::self );
        Vec3d_exposer.def( bp::self /= bp::other< double >() );
        { //::nacb::Vec3<double>::operator=
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef void ( exported_class_t::*assign_function_type )( ::nacb::Vec3<double> const & ) ;
            
            Vec3d_exposer.def( 
                "assign"
                , assign_function_type( &::nacb::Vec3<double>::operator= )
                , ( bp::arg("o") ) );
        
        }
        Vec3d_exposer.def( bp::self == bp::self );
        { //::nacb::Vec3<double>::operator[]
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef double & ( exported_class_t::*__getitem___function_type )( int ) ;
            
            Vec3d_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Vec3<double>::operator[] )
                , ( bp::arg("i") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        Vec3d_exposer.def( bp::self ^ bp::self );
        { //::nacb::Vec3<double>::print
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef void ( exported_class_t::*print_function_type )( ::std::ostream & ) const;
            
            Vec3d_exposer.def( 
                "print"
                , print_function_type( &::nacb::Vec3<double>::print )
                , ( bp::arg("arg0") ) );
        
        }
        { //::nacb::Vec3<double>::python_set
        
            typedef nacb::Vec3<double> exported_class_t;
            typedef void ( exported_class_t::*python_set_function_type )( int,double ) ;
            
            Vec3d_exposer.def( 
                "python_set"
                , python_set_function_type( &::nacb::Vec3<double>::python_set )
                , ( bp::arg("i"), bp::arg("t") ) );
        
        }
        Vec3d_exposer.def_readwrite( "x", &nacb::Vec3<double>::x );
        Vec3d_exposer.def_readwrite( "y", &nacb::Vec3<double>::y );
        Vec3d_exposer.def_readwrite( "z", &nacb::Vec3<double>::z );
        Vec3d_exposer.def("__setitem__",&::nacb::Vec3<double>::python_set);
    }

    bp::implicitly_convertible< nacb::Vec3<double>, std::string >();

    { //::nacb::Quaternion
        typedef bp::class_< nacb::Quaternion > Quaternion_exposer_t;
        Quaternion_exposer_t Quaternion_exposer = Quaternion_exposer_t( "Quaternion", bp::init< nacb::Quaternion const & >(( bp::arg("q") )) );
        bp::scope Quaternion_scope( Quaternion_exposer );
        Quaternion_exposer.def( bp::init< nacb::Vec3d const &, double >(( bp::arg("v"), bp::arg("a") )) );
        Quaternion_exposer.def( bp::init< bp::optional< double, nacb::Vec3d const & > >(( bp::arg("a")=1, bp::arg("v")=::nacb::Vec3d( 0.0, 0.0, 0.0 ) )) );
        { //::nacb::Quaternion::conj
        
            typedef ::nacb::Quaternion ( ::nacb::Quaternion::*conj_function_type )(  ) const;
            
            Quaternion_exposer.def( 
                "conj"
                , conj_function_type( &::nacb::Quaternion::conj ) );
        
        }
        { //::nacb::Quaternion::dot
        
            typedef double ( ::nacb::Quaternion::*dot_function_type )( ::nacb::Quaternion const & ) const;
            
            Quaternion_exposer.def( 
                "dot"
                , dot_function_type( &::nacb::Quaternion::dot )
                , ( bp::arg("q") ) );
        
        }
        { //::nacb::Quaternion::fromMatrix
        
            typedef ::nacb::Quaternion ( *fromMatrix_function_type )( ::nacb::Mat3x3 const & );
            
            Quaternion_exposer.def( 
                "fromMatrix"
                , fromMatrix_function_type( &::nacb::Quaternion::fromMatrix )
                , ( bp::arg("mat") ) );
        
        }
        { //::nacb::Quaternion::fromMatrix
        
            typedef ::nacb::Quaternion ( *fromMatrix_function_type )( ::nacb::Mat4x4 const & );
            
            Quaternion_exposer.def( 
                "fromMatrix"
                , fromMatrix_function_type( &::nacb::Quaternion::fromMatrix )
                , ( bp::arg("mat") ) );
        
        }
        { //::nacb::Quaternion::fromMatrixRows
        
            typedef ::nacb::Quaternion ( *fromMatrixRows_function_type )( ::nacb::Vec3d const &,::nacb::Vec3d const &,::nacb::Vec3d const & );
            
            Quaternion_exposer.def( 
                "fromMatrixRows"
                , fromMatrixRows_function_type( &::nacb::Quaternion::fromMatrixRows )
                , ( bp::arg("r1"), bp::arg("r2"), bp::arg("r3") ) );
        
        }
        { //::nacb::Quaternion::getMatrix
        
            typedef void ( ::nacb::Quaternion::*getMatrix_function_type )( ::nacb::Mat3x3 & ) const;
            
            Quaternion_exposer.def( 
                "getMatrix"
                , getMatrix_function_type( &::nacb::Quaternion::getMatrix )
                , ( bp::arg("mat") ) );
        
        }
        { //::nacb::Quaternion::getMatrixCols
        
            typedef void ( ::nacb::Quaternion::*getMatrixCols_function_type )( ::nacb::Vec3d &,::nacb::Vec3d &,::nacb::Vec3d & ) const;
            
            Quaternion_exposer.def( 
                "getMatrixCols"
                , getMatrixCols_function_type( &::nacb::Quaternion::getMatrixCols )
                , ( bp::arg("c0"), bp::arg("c1"), bp::arg("c2") ) );
        
        }
        { //::nacb::Quaternion::getMatrixRows
        
            typedef void ( ::nacb::Quaternion::*getMatrixRows_function_type )( ::nacb::Vec3d &,::nacb::Vec3d &,::nacb::Vec3d & ) const;
            
            Quaternion_exposer.def( 
                "getMatrixRows"
                , getMatrixRows_function_type( &::nacb::Quaternion::getMatrixRows )
                , ( bp::arg("r0"), bp::arg("r1"), bp::arg("r2") ) );
        
        }
        { //::nacb::Quaternion::glRotate
        
            typedef void ( ::nacb::Quaternion::*glRotate_function_type )(  ) const;
            
            Quaternion_exposer.def( 
                "glRotate"
                , glRotate_function_type( &::nacb::Quaternion::glRotate ) );
        
        }
        { //::nacb::Quaternion::len
        
            typedef double ( ::nacb::Quaternion::*len_function_type )(  ) ;
            
            Quaternion_exposer.def( 
                "len"
                , len_function_type( &::nacb::Quaternion::len ) );
        
        }
        { //::nacb::Quaternion::normalize
        
            typedef double ( ::nacb::Quaternion::*normalize_function_type )(  ) ;
            
            Quaternion_exposer.def( 
                "normalize"
                , normalize_function_type( &::nacb::Quaternion::normalize ) );
        
        }
        Quaternion_exposer.def( "__str__", &nacb::Quaternion::operator ::std::string  );
        Quaternion_exposer.def( bp::self * bp::self );
        Quaternion_exposer.def( bp::self *= bp::other< double >() );
        Quaternion_exposer.def( bp::self *= bp::self );
        Quaternion_exposer.def( bp::self + bp::self );
        Quaternion_exposer.def( bp::self /= bp::other< double >() );
        { //::nacb::Quaternion::operator=
        
            typedef void ( ::nacb::Quaternion::*assign_function_type )( ::nacb::Quaternion const & ) ;
            
            Quaternion_exposer.def( 
                "assign"
                , assign_function_type( &::nacb::Quaternion::operator= )
                , ( bp::arg("q") ) );
        
        }
        { //::nacb::Quaternion::print
        
            typedef void ( ::nacb::Quaternion::*print_function_type )( ::std::ostream & ) const;
            
            Quaternion_exposer.def( 
                "print"
                , print_function_type( &::nacb::Quaternion::print )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Quaternion::print
        
            typedef void ( ::nacb::Quaternion::*print_function_type )( char * ) ;
            
            Quaternion_exposer.def( 
                "print"
                , print_function_type( &::nacb::Quaternion::print )
                , ( bp::arg("name")=bp::object() ) );
        
        }
        { //::nacb::Quaternion::rod
        
            typedef ::nacb::Quaternion ( *rod_function_type )( ::nacb::Vec3d const & );
            
            Quaternion_exposer.def( 
                "rod"
                , rod_function_type( &::nacb::Quaternion::rod )
                , ( bp::arg("v")=::nacb::Vec3d( 0.0, 0.0, 0.0 ) ) );
        
        }
        { //::nacb::Quaternion::rod_dx
        
            typedef ::nacb::Quaternion ( *rod_dx_function_type )( ::nacb::Vec3d const & );
            
            Quaternion_exposer.def( 
                "rod_dx"
                , rod_dx_function_type( &::nacb::Quaternion::rod_dx )
                , ( bp::arg("v") ) );
        
        }
        { //::nacb::Quaternion::rod_dy
        
            typedef ::nacb::Quaternion ( *rod_dy_function_type )( ::nacb::Vec3d const & );
            
            Quaternion_exposer.def( 
                "rod_dy"
                , rod_dy_function_type( &::nacb::Quaternion::rod_dy )
                , ( bp::arg("v") ) );
        
        }
        { //::nacb::Quaternion::rod_dz
        
            typedef ::nacb::Quaternion ( *rod_dz_function_type )( ::nacb::Vec3d const & );
            
            Quaternion_exposer.def( 
                "rod_dz"
                , rod_dz_function_type( &::nacb::Quaternion::rod_dz )
                , ( bp::arg("v") ) );
        
        }
        { //::nacb::Quaternion::rotate
        
            typedef ::nacb::Vec3d ( ::nacb::Quaternion::*rotate_function_type )( ::nacb::Vec3d const & ) const;
            
            Quaternion_exposer.def( 
                "rotate"
                , rotate_function_type( &::nacb::Quaternion::rotate )
                , ( bp::arg("pt") ) );
        
        }
        { //::nacb::Quaternion::rotateNormal
        
            typedef ::nacb::Vec3d ( ::nacb::Quaternion::*rotateNormal_function_type )( ::nacb::Vec3d const & ) ;
            
            Quaternion_exposer.def( 
                "rotateNormal"
                , rotateNormal_function_type( &::nacb::Quaternion::rotateNormal )
                , ( bp::arg("n") ) );
        
        }
        { //::nacb::Quaternion::slerp
        
            typedef ::nacb::Quaternion ( *slerp_function_type )( double,::nacb::Quaternion const &,::nacb::Quaternion const & );
            
            Quaternion_exposer.def( 
                "slerp"
                , slerp_function_type( &::nacb::Quaternion::slerp )
                , ( bp::arg("t"), bp::arg("q1"), bp::arg("q2") ) );
        
        }
        { //::nacb::Quaternion::times
        
            typedef ::nacb::Quaternion ( ::nacb::Quaternion::*times_function_type )( ::nacb::Quaternion const & ) const;
            
            Quaternion_exposer.def( 
                "times"
                , times_function_type( &::nacb::Quaternion::times )
                , ( bp::arg("q") ) );
        
        }
        { //::nacb::Quaternion::toEuler
        
            typedef void ( ::nacb::Quaternion::*toEuler_function_type )( char const *,double * ) const;
            
            Quaternion_exposer.def( 
                "toEuler"
                , toEuler_function_type( &::nacb::Quaternion::toEuler )
                , ( bp::arg("order"), bp::arg("angles") ) );
        
        }
        Quaternion_exposer.def_readwrite( "a", &nacb::Quaternion::a );
        Quaternion_exposer.def_readwrite( "v", &nacb::Quaternion::v );
        Quaternion_exposer.staticmethod( "fromMatrix" );
        Quaternion_exposer.staticmethod( "fromMatrixRows" );
        Quaternion_exposer.staticmethod( "rod" );
        Quaternion_exposer.staticmethod( "rod_dx" );
        Quaternion_exposer.staticmethod( "rod_dy" );
        Quaternion_exposer.staticmethod( "rod_dz" );
        Quaternion_exposer.staticmethod( "slerp" );
    }

    bp::implicitly_convertible< nacb::Quaternion, std::string >();

    bp::class_< nacb::Vec2<double> >( "Vec2d", bp::init< bp::optional< double const &, double const & > >(( bp::arg("xin")=0, bp::arg("yin")=0 )) )    
        .def( 
            "dot"
            , &::nacb::Vec2<double>::dot
            , ( bp::arg("o") ) )    
        .def( 
            "getData"
            , &::nacb::Vec2<double>::getData
            , bp::return_value_policy< bp::return_by_value >() )    
        .def( 
            "len"
            , &::nacb::Vec2<double>::len )    
        .def( 
            "max"
            , &::nacb::Vec2<double>::max
            , ( bp::arg("o") ) )    
        .def( 
            "min"
            , &::nacb::Vec2<double>::min
            , ( bp::arg("o") ) )    
        .def( 
            "normalize"
            , &::nacb::Vec2<double>::normalize )    
        .def( bp::self * bp::other< double >() )    
        .def( bp::self *= bp::other< double >() )    
        .def( bp::self + bp::self )    
        .def( bp::self += bp::self )    
        .def( bp::self - bp::self )    
        .def( bp::self -= bp::self )    
        .def( bp::self / bp::other< double >() )    
        .def( bp::self /= bp::other< double >() )    
        .def( bp::self == bp::self )    
        .def( 
            "__getitem__"
            , &::nacb::Vec2<double>::operator[]
            , ( bp::arg("i") )
            , bp::return_value_policy< bp::copy_non_const_reference >() )    
        .def( 
            "python_set"
            , &::nacb::Vec2<double>::python_set
            , ( bp::arg("i"), bp::arg("t") ) )    
        .def_readwrite( "x", &nacb::Vec2<double>::x )    
        .def_readwrite( "y", &nacb::Vec2<double>::y )    
        .def("__setitem__",&::nacb::Vec2<double>::python_set);

    bp::class_< nacb::Vec2<float> >( "Vec2f", bp::init< bp::optional< float const &, float const & > >(( bp::arg("xin")=0, bp::arg("yin")=0 )) )    
        .def( 
            "dot"
            , &::nacb::Vec2<float>::dot
            , ( bp::arg("o") ) )    
        .def( 
            "getData"
            , &::nacb::Vec2<float>::getData
            , bp::return_value_policy< bp::return_by_value >() )    
        .def( 
            "len"
            , &::nacb::Vec2<float>::len )    
        .def( 
            "max"
            , &::nacb::Vec2<float>::max
            , ( bp::arg("o") ) )    
        .def( 
            "min"
            , &::nacb::Vec2<float>::min
            , ( bp::arg("o") ) )    
        .def( 
            "normalize"
            , &::nacb::Vec2<float>::normalize )    
        .def( bp::self * bp::other< double >() )    
        .def( bp::self *= bp::other< double >() )    
        .def( bp::self + bp::self )    
        .def( bp::self += bp::self )    
        .def( bp::self - bp::self )    
        .def( bp::self -= bp::self )    
        .def( bp::self / bp::other< double >() )    
        .def( bp::self /= bp::other< double >() )    
        .def( bp::self == bp::self )    
        .def( 
            "__getitem__"
            , &::nacb::Vec2<float>::operator[]
            , ( bp::arg("i") )
            , bp::return_value_policy< bp::copy_non_const_reference >() )    
        .def( 
            "python_set"
            , &::nacb::Vec2<float>::python_set
            , ( bp::arg("i"), bp::arg("t") ) )    
        .def_readwrite( "x", &nacb::Vec2<float>::x )    
        .def_readwrite( "y", &nacb::Vec2<float>::y )    
        .def("__setitem__",&::nacb::Vec2<float>::python_set);

    { //::nacb::Vec3<float>
        typedef bp::class_< nacb::Vec3<float> > Vec3f_exposer_t;
        Vec3f_exposer_t Vec3f_exposer = Vec3f_exposer_t( "Vec3f", bp::init< nacb::Vec3<float> const & >(( bp::arg("other") )) );
        bp::scope Vec3f_scope( Vec3f_exposer );
        Vec3f_exposer.def( bp::init< bp::optional< float, float, float > >(( bp::arg("x")=0, bp::arg("y")=0, bp::arg("z")=0 )) );
        { //::nacb::Vec3<float>::cross
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef ::nacb::Vec3<float> ( exported_class_t::*cross_function_type )( ::nacb::Vec3<float> const & ) const;
            
            Vec3f_exposer.def( 
                "cross"
                , cross_function_type( &::nacb::Vec3<float>::cross )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<float>::dot
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef double ( exported_class_t::*dot_function_type )( ::nacb::Vec3<float> const & ) const;
            
            Vec3f_exposer.def( 
                "dot"
                , dot_function_type( &::nacb::Vec3<float>::dot )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<float>::getData
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef float * ( exported_class_t::*getData_function_type )(  ) ;
            
            Vec3f_exposer.def( 
                "getData"
                , getData_function_type( &::nacb::Vec3<float>::getData )
                , bp::return_value_policy< bp::return_by_value >() );
        
        }
        { //::nacb::Vec3<float>::len
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef double ( exported_class_t::*len_function_type )(  ) const;
            
            Vec3f_exposer.def( 
                "len"
                , len_function_type( &::nacb::Vec3<float>::len ) );
        
        }
        { //::nacb::Vec3<float>::max
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef ::nacb::Vec3<float> ( exported_class_t::*max_function_type )( ::nacb::Vec3<float> const & ) const;
            
            Vec3f_exposer.def( 
                "max"
                , max_function_type( &::nacb::Vec3<float>::max )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<float>::min
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef ::nacb::Vec3<float> ( exported_class_t::*min_function_type )( ::nacb::Vec3<float> const & ) const;
            
            Vec3f_exposer.def( 
                "min"
                , min_function_type( &::nacb::Vec3<float>::min )
                , ( bp::arg("o") ) );
        
        }
        { //::nacb::Vec3<float>::normalize
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef double ( exported_class_t::*normalize_function_type )(  ) ;
            
            Vec3f_exposer.def( 
                "normalize"
                , normalize_function_type( &::nacb::Vec3<float>::normalize ) );
        
        }
        Vec3f_exposer.def( "__str__", &nacb::Vec3<float>::operator ::std::string  );
        Vec3f_exposer.def( bp::self * bp::self );
        Vec3f_exposer.def( bp::self * bp::other< double >() );
        Vec3f_exposer.def( bp::self *= bp::other< double >() );
        Vec3f_exposer.def( bp::self + bp::self );
        Vec3f_exposer.def( bp::self += bp::self );
        Vec3f_exposer.def( bp::self - bp::self );
        Vec3f_exposer.def( bp::self -= bp::self );
        Vec3f_exposer.def( bp::self /= bp::other< double >() );
        { //::nacb::Vec3<float>::operator=
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef void ( exported_class_t::*assign_function_type )( ::nacb::Vec3<float> const & ) ;
            
            Vec3f_exposer.def( 
                "assign"
                , assign_function_type( &::nacb::Vec3<float>::operator= )
                , ( bp::arg("o") ) );
        
        }
        Vec3f_exposer.def( bp::self == bp::self );
        { //::nacb::Vec3<float>::operator[]
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef float & ( exported_class_t::*__getitem___function_type )( int ) ;
            
            Vec3f_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::nacb::Vec3<float>::operator[] )
                , ( bp::arg("i") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        Vec3f_exposer.def( bp::self ^ bp::self );
        { //::nacb::Vec3<float>::print
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef void ( exported_class_t::*print_function_type )( ::std::ostream & ) const;
            
            Vec3f_exposer.def( 
                "print"
                , print_function_type( &::nacb::Vec3<float>::print )
                , ( bp::arg("arg0") ) );
        
        }
        { //::nacb::Vec3<float>::python_set
        
            typedef nacb::Vec3<float> exported_class_t;
            typedef void ( exported_class_t::*python_set_function_type )( int,float ) ;
            
            Vec3f_exposer.def( 
                "python_set"
                , python_set_function_type( &::nacb::Vec3<float>::python_set )
                , ( bp::arg("i"), bp::arg("t") ) );
        
        }
        Vec3f_exposer.def_readwrite( "x", &nacb::Vec3<float>::x );
        Vec3f_exposer.def_readwrite( "y", &nacb::Vec3<float>::y );
        Vec3f_exposer.def_readwrite( "z", &nacb::Vec3<float>::z );
        Vec3f_exposer.def("__setitem__",&::nacb::Vec3<float>::python_set);
    }

    bp::implicitly_convertible< nacb::Vec3<float>, std::string >();

    bp::class_< nacb::Vec4<double> >( "Vec4d", bp::init< bp::optional< double, double, double, double > >(( bp::arg("xin")=0, bp::arg("yin")=0, bp::arg("zin")=0, bp::arg("win")=1 )) )    
        .def( bp::init< nacb::Vec4<double> const & >(( bp::arg("o") )) )    
        .def( 
            "cross"
            , &::nacb::Vec4<double>::cross
            , ( bp::arg("o") ) )    
        .def( 
            "dx"
            , &::nacb::Vec4<double>::dx
            , ( bp::arg("t") ) )    
        .def( 
            "dy"
            , &::nacb::Vec4<double>::dy
            , ( bp::arg("t") ) )    
        .def( 
            "dz"
            , &::nacb::Vec4<double>::dz
            , ( bp::arg("t") ) )    
        .def( 
            "getData"
            , &::nacb::Vec4<double>::getData
            , bp::return_value_policy< bp::return_by_value >() )    
        .def( 
            "len"
            , &::nacb::Vec4<double>::len )    
        .def( 
            "normalize"
            , &::nacb::Vec4<double>::normalize )    
        .def( "__str__", &nacb::Vec4<double>::operator ::std::string  )    
        .def( bp::self * bp::other< double >() )    
        .def( bp::self * bp::self )    
        .def( bp::self *= bp::self )    
        .def( bp::self *= bp::other< double >() )    
        .def( bp::self + bp::self )    
        .def( bp::self += bp::self )    
        .def( bp::self - bp::self )    
        .def( bp::self -= bp::self )    
        .def( bp::self / bp::other< double >() )    
        .def( bp::self /= bp::other< double >() )    
        .def( bp::self == bp::self )    
        .def( 
            "__getitem__"
            , &::nacb::Vec4<double>::operator[]
            , ( bp::arg("i") )
            , bp::return_value_policy< bp::copy_non_const_reference >() )    
        .def( bp::self ^ bp::self )    
        .def( 
            "print"
            , &::nacb::Vec4<double>::print
            , ( bp::arg("os") ) )    
        .def( 
            "python_set"
            , &::nacb::Vec4<double>::python_set
            , ( bp::arg("i"), bp::arg("t") ) )    
        .def( 
            "rotatex"
            , &::nacb::Vec4<double>::rotatex
            , ( bp::arg("t") ) )    
        .def( 
            "rotatey"
            , &::nacb::Vec4<double>::rotatey
            , ( bp::arg("t") ) )    
        .def( 
            "rotatez"
            , &::nacb::Vec4<double>::rotatez
            , ( bp::arg("t") ) )    
        .def( 
            "rotx"
            , &::nacb::Vec4<double>::rotx
            , ( bp::arg("t") ) )    
        .def( 
            "roty"
            , &::nacb::Vec4<double>::roty
            , ( bp::arg("t") ) )    
        .def( 
            "rotz"
            , &::nacb::Vec4<double>::rotz
            , ( bp::arg("t") ) )    
        .def_readwrite( "w", &nacb::Vec4<double>::w )    
        .def_readwrite( "x", &nacb::Vec4<double>::x )    
        .def_readwrite( "y", &nacb::Vec4<double>::y )    
        .def_readwrite( "z", &nacb::Vec4<double>::z )    
        .def("__setitem__",&::nacb::Vec4<double>::python_set);

    bp::implicitly_convertible< nacb::Vec4<double>, std::string >();

    bp::class_< nacb::Vec4<float> >( "Vec4f", bp::init< bp::optional< float, float, float, float > >(( bp::arg("xin")=0, bp::arg("yin")=0, bp::arg("zin")=0, bp::arg("win")=1 )) )    
        .def( bp::init< nacb::Vec4<float> const & >(( bp::arg("o") )) )    
        .def( 
            "cross"
            , &::nacb::Vec4<float>::cross
            , ( bp::arg("o") ) )    
        .def( 
            "dx"
            , &::nacb::Vec4<float>::dx
            , ( bp::arg("t") ) )    
        .def( 
            "dy"
            , &::nacb::Vec4<float>::dy
            , ( bp::arg("t") ) )    
        .def( 
            "dz"
            , &::nacb::Vec4<float>::dz
            , ( bp::arg("t") ) )    
        .def( 
            "getData"
            , &::nacb::Vec4<float>::getData
            , bp::return_value_policy< bp::return_by_value >() )    
        .def( 
            "len"
            , &::nacb::Vec4<float>::len )    
        .def( 
            "normalize"
            , &::nacb::Vec4<float>::normalize )    
        .def( "__str__", &nacb::Vec4<float>::operator ::std::string  )    
        .def( bp::self * bp::other< double >() )    
        .def( bp::self * bp::self )    
        .def( bp::self *= bp::self )    
        .def( bp::self *= bp::other< double >() )    
        .def( bp::self + bp::self )    
        .def( bp::self += bp::self )    
        .def( bp::self - bp::self )    
        .def( bp::self -= bp::self )    
        .def( bp::self / bp::other< double >() )    
        .def( bp::self /= bp::other< double >() )    
        .def( bp::self == bp::self )    
        .def( 
            "__getitem__"
            , &::nacb::Vec4<float>::operator[]
            , ( bp::arg("i") )
            , bp::return_value_policy< bp::copy_non_const_reference >() )    
        .def( bp::self ^ bp::self )    
        .def( 
            "print"
            , &::nacb::Vec4<float>::print
            , ( bp::arg("os") ) )    
        .def( 
            "python_set"
            , &::nacb::Vec4<float>::python_set
            , ( bp::arg("i"), bp::arg("t") ) )    
        .def( 
            "rotatex"
            , &::nacb::Vec4<float>::rotatex
            , ( bp::arg("t") ) )    
        .def( 
            "rotatey"
            , &::nacb::Vec4<float>::rotatey
            , ( bp::arg("t") ) )    
        .def( 
            "rotatez"
            , &::nacb::Vec4<float>::rotatez
            , ( bp::arg("t") ) )    
        .def( 
            "rotx"
            , &::nacb::Vec4<float>::rotx
            , ( bp::arg("t") ) )    
        .def( 
            "roty"
            , &::nacb::Vec4<float>::roty
            , ( bp::arg("t") ) )    
        .def( 
            "rotz"
            , &::nacb::Vec4<float>::rotz
            , ( bp::arg("t") ) )    
        .def_readwrite( "w", &nacb::Vec4<float>::w )    
        .def_readwrite( "x", &nacb::Vec4<float>::x )    
        .def_readwrite( "y", &nacb::Vec4<float>::y )    
        .def_readwrite( "z", &nacb::Vec4<float>::z )    
        .def("__setitem__",&::nacb::Vec4<float>::python_set);

    bp::implicitly_convertible< nacb::Vec4<float>, std::string >();
}
