from distutils.core import setup, Extension
import sipdistutils

import commands

def pkgconfig(*packages, **kw):
    flag_map = {'-I': 'include_dirs', '-L': 'library_dirs', '-l': 'libraries'}
    for token in commands.getoutput("pkg-config --libs --cflags %s" % ' '.join(packages)).split():
        kw.setdefault(flag_map.get(token[:2]), []).append(token[2:])
    return kw

setup(
  name = 'nmath',
  version = '0.0.1',
  description = 'Bindings for nmath (generated by sip)',
  ext_modules=[
    Extension("nmath", ["nmath.sip"],**pkgconfig('nmath'))
    ],
  data_files = [('/usr/share/sip/',['nmath.sip'])],

  cmdclass = {'build_ext': sipdistutils.build_ext}
)
